'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.retry = exports.delay = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var delay = exports.delay = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(timeoutMs) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt('return', new _promise2.default(function (resolve) {
              return setTimeout(resolve, timeoutMs);
            }));

          case 1:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function delay(_x) {
    return _ref.apply(this, arguments);
  };
}();

var retry = exports.retry = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(iteratee, interval, timeoutMs) {
    var firstTry, retries, iterations;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            firstTry = iteratee();

            if (!firstTry) {
              _context2.next = 3;
              break;
            }

            return _context2.abrupt('return', firstTry);

          case 3:
            retries = timeoutMs / interval;
            iterations = 0;
            return _context2.abrupt('return', new _promise2.default(function (resolve) {
              var iterator = setInterval(function () {
                iterations += 1;

                var iterateeReturn = iteratee();

                if (iterateeReturn || iterations >= retries) {
                  resolve(iterateeReturn);
                  clearInterval(iterator);
                }
              }, interval);
            }));

          case 6:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function retry(_x2, _x3, _x4) {
    return _ref2.apply(this, arguments);
  };
}();

exports.setNames = setNames;
exports.defaultGetAppNameFromUrl = defaultGetAppNameFromUrl;
exports.getDefaultStatusDetails = getDefaultStatusDetails;
exports.getLoadingStatusDetails = getLoadingStatusDetails;
exports.getErrorStatusDetails = getErrorStatusDetails;

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function setNames(map) {
  return (0, _keys2.default)(map || {}).reduce(function (acc, key) {
    return (0, _assign2.default)({}, acc, (0, _defineProperty3.default)({}, key, (0, _assign2.default)({}, map[key], { name: key })));
  }, {});
}

function defaultGetAppNameFromUrl(apps) {
  return function getAppNameFromUrl(url) {
    var _url$split = url.split('?'),
        _url$split2 = (0, _slicedToArray3.default)(_url$split, 1),
        path = _url$split2[0];

    return (0, _keys2.default)(apps).find(function (appName) {
      var app = apps[appName];
      return Array.isArray(app.appPaths) ? app.appPaths.indexOf(path) !== -1 : path === app.appPath;
    });
  };
}

function getDefaultStatusDetails() {
  return {
    level: _constants.levels.INFO,
    status: _constants.statuses.DEFAULT
  };
}

function getLoadingStatusDetails() {
  return {
    level: _constants.levels.INFO,
    status: _constants.statuses.LOADING
  };
}

function getErrorStatusDetails(amError) {
  return {
    level: amError.level || _constants.levels.ERROR,
    status: _constants.statuses.ERROR,
    message: amError.message
  };
}