'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = initGetState;

var _appManagerError = require('./app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function initGetState(apps, options) {
  return function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(url, prevApp, eventTitle) {
      var path, errData, appName, additionalState;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              path = url.split('?')[0];
              errData = {
                source: 'get_state',
                fragment: null,
                slot: null,
                path: path
              };
              appName = null;

              if (!(typeof options.getAppNameFromUrl === 'function')) {
                _context.next = 13;
                break;
              }

              _context.prev = 4;
              _context.next = 7;
              return options.getAppNameFromUrl(url);

            case 7:
              appName = _context.sent;
              _context.next = 13;
              break;

            case 10:
              _context.prev = 10;
              _context.t0 = _context['catch'](4);
              throw new _appManagerError2.default(_context.t0, (0, _assign2.default)({}, errData, {
                app: appName,
                level: _constants.levels.ERROR,
                code: 'get_app_name_from_location',
                recoverable: false
              }));

            case 13:
              if (appName) {
                _context.next = 15;
                break;
              }

              return _context.abrupt('return', null);

            case 15:
              additionalState = {};

              if (!(typeof options.getAdditionalState === 'function')) {
                _context.next = 26;
                break;
              }

              _context.prev = 17;
              _context.next = 20;
              return options.getAdditionalState(appName, url);

            case 20:
              additionalState = _context.sent;
              _context.next = 26;
              break;

            case 23:
              _context.prev = 23;
              _context.t1 = _context['catch'](17);
              throw new _appManagerError2.default(_context.t1, (0, _assign2.default)({}, errData, {
                app: appName,
                level: _constants.levels.ERROR,
                code: 'get_additional_state',
                recoverable: false
              }));

            case 26:
              return _context.abrupt('return', (0, _assign2.default)({}, additionalState, {
                event: eventTitle && typeof eventTitle === 'string' ? eventTitle : null,
                path: path,
                prevApp: prevApp,
                app: apps[appName]
              }));

            case 27:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this, [[4, 10], [17, 23]]);
    }));

    function getState(_x, _x2, _x3) {
      return _ref.apply(this, arguments);
    }

    return getState;
  }();
}