'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

exports.default = getPathHelpers;

var _pathToRegexp = require('path-to-regexp');

var _pathToRegexp2 = _interopRequireDefault(_pathToRegexp);

var _qs = require('qs');

var _qs2 = _interopRequireDefault(_qs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-line import/no-extraneous-dependencies

function getPathHelpers(appPathsMap) {
  function getPaths(appName) {
    var _appPathsMap$appName = appPathsMap[appName],
        appPath = _appPathsMap$appName.appPath,
        appPaths = _appPathsMap$appName.appPaths;


    var paths = [];

    if (Array.isArray(appPaths) && appPaths.length > 0) {
      paths = appPaths;
    } else if (appPath) {
      paths = [appPath];
    }

    if (paths.length === 0) {
      throw new Error('App ' + appName + ' has no valid appPaths specified.');
    }

    return paths;
  }

  function parsePath(path) {
    return _pathToRegexp2.default.parse(path).filter(function (key) {
      return (typeof key === 'undefined' ? 'undefined' : (0, _typeof3.default)(key)) === 'object';
    }).map(function (_ref) {
      var name = _ref.name;
      return name;
    });
  }

  var pathParams = (0, _keys2.default)(appPathsMap || {}).reduce(function (evaluatedPaths, appName) {
    return (0, _assign2.default)({}, evaluatedPaths, (0, _defineProperty3.default)({}, appName, getPaths(appName).map(parsePath)));
  }, {});

  var pathCheckers = (0, _keys2.default)(appPathsMap || {}).reduce(function (evaluatedPaths, appName) {
    return (0, _assign2.default)({}, evaluatedPaths, (0, _defineProperty3.default)({}, appName, getPaths(appName).map(function (path) {
      return (0, _pathToRegexp2.default)(path);
    })));
  }, {});

  function evalPathParams(appName, path) {
    return pathCheckers[appName].reduce(function (thing, checker, index) {
      if (thing) {
        return thing;
      }

      var match = checker.exec(path);

      if (!match) {
        return thing;
      }

      var params = match.filter(function (token, idx) {
        return idx > 0;
      }).reduce(function (acc, token, idx) {
        return (0, _assign2.default)({}, acc, (0, _defineProperty3.default)({}, pathParams[appName][index][idx], token));
      }, {});

      return params;
    }, null);
  }

  return {
    getAppNameFromUrl: function getAppNameFromUrl(url) {
      var _url$split = url.split('?'),
          _url$split2 = (0, _slicedToArray3.default)(_url$split, 1),
          path = _url$split2[0];

      return (0, _keys2.default)(pathCheckers).find(function (appName) {
        return pathCheckers[appName].find(function (checker) {
          return checker.exec(path);
        });
      });
    },
    getAdditionalState: function getAdditionalState(appName, url) {
      var _url$split3 = url.split('?'),
          _url$split4 = (0, _slicedToArray3.default)(_url$split3, 2),
          path = _url$split4[0],
          search = _url$split4[1];

      return {
        params: evalPathParams(appName, path) || {},
        query: _qs2.default.parse(search, { ignoreQueryPrefix: true })
      };
    }
  };
} // eslint-disable-line import/no-extraneous-dependencies